# -*- encoding: utf-8 -*-

import requests

URL_BASE = 'http://www.futebits.com.br/ws/api/'

class ConnectionError(Exception):
    pass

class Team(object):
    def next_match(self, id_team):
        '''Returns the information the next game a certain team.'''
        try:
            response = requests.get(URL_BASE + ('getProximoJogo/%d' % id_team)).json()
        except:
            raise ConnectionError('Connection failed!')
        return response

    def last_match(self, id_team):
        '''Returns the information of the last game of a particular team.'''
        try:
            response = requests.get(URL_BASE + ('getUltimoJogo/%d' % id_team)).json()
        except:
            raise ConnectionError('Connection failed!')
        return response

    def data_team(self, id_team):
        '''Returns information of a team.'''
        try:
            response = requests.get(URL_BASE + ('getDadosEquipe/%d' % id_team)).json()
        except:
            raise ConnectionError('Connection failed!')
        return response

    def game_next_team(self, id_team, championship="Campeonato Brasileiro"):
        '''Returns information of a team.'''
        try:
            response = requests.get(URL_BASE + ('getRodadaSeguintePorEquipe/%s/%d' % (championship, id_team))).json()
        except:
            raise ConnectionError('Connection failed!')
        return response

    def game_last_team(self, id_team, championship="Campeonato Brasileiro"):
        '''Returns information of a team.'''
        try:
            response = requests.get(URL_BASE + ('getUltimaRodadaPorEquipe/%s/%d' % (championship, id_team))).json()
        except:
            raise ConnectionError('Connection failed!')
        return response

    def game_current_team(self, id_team, championship="Campeonato Brasileiro"):
        '''Returns information of a team.'''
        try:
            response = requests.get(URL_BASE + ('getRodadaAtualPorEquipe/%s/%d' % (championship, id_team))).json()
        except:
            raise ConnectionError('Connection failed!')
        return response

    def games(self, id_team):
        '''Returns a list of dictionaries'''
        try:
            response = requests.get(URL_BASE + ('getJogos/%d' % (id_team))).json()
        except:
            raise ConnectionError('Connection failed!')
        return response

    def identifier_team(self):
        '''Returns a list of dictionaries'''
        try:
            response = requests.get(URL_BASE + ('getIdentificadorEquipes')).json()
        except:
            raise ConnectionError('Connection failed!')
        return response

    def current_table_championship_team(self, id_team, championship="Campeonato Brasileiro"):
        '''Returns a list of dictionaries'''
        try:
            response = requests.get(URL_BASE + ('getTabelaAtualCampeonatoEquipe/%s/%d' % (championship, id_team))).json()
        except:
            raise ConnectionError('Connection failed!')
        return response

class Championship(object):

        def championship(self):
            '''Returns a list of dictionaries'''
            try:
                response = requests.get(URL_BASE + ('getCampeonatos')).json()
            except:
                raise ConnectionError('Connection failed!')
            return response

        def phase_edition(self, division, year, championship='Campeonato Brasileiro'):
            try:
                response = requests.get(URL_BASE + ('getFasesEdicao/%s/%s/%s' % (championship, division, year))).json()
            except:
                raise ConnectionError('Connection failed!')
            return response

        def phase_groups(self, division, year, phase, championship='Campeonato Brasileiro'):
            try:
                response = requests.get(URL_BASE + ('getGruposFase/%s/%s/%s/%s' % (championship, division, year, phase))).json()
            except:
                raise ConnectionError('Connection failed!')
            return response

class Game(object):

        def game(self, division, year, phase, group_name, game, championship='Campeonato Brasileiro'):
            try:
                response = requests.get(URL_BASE + ('getRodada/%s/%s/%s/%s/%s/%s' % (championship, division, year, phase, group_name, game))).json()
            except:
                raise ConnectionError('Connection failed!')
            return response

        def current_game(self, division, year, phase, group_name, game, championship='Campeonato Brasileiro'):
            try:
                response = requests.get(URL_BASE + ('getRodadaAtual/%s/%s/%s/%s/%s/%s' % (championship, division, year, phase, group_name, game))).json()
            except:
                raise ConnectionError('Connection failed!')
            return response
